image: "python:3.9"

before_script:
  - python --version
  - pip install -r requirements.txt

stages:
  - Static Analysis
  - Formatting
  - Security
  - Test

mypy:
  stage: Static Analysis
  script:
  - python -m mypy bild/file.py
  - python -m mypy bild/directory.py

flake8:
  stage: Static Analysis
  script:
  - flake8 --max-line-length=120 --max-complexity 8 bild/*.py

pylint:
  stage: Static Analysis
  script:
  - pylint -d C0301 -d R0902 bild/*.py

isort:
  stage: Formatting
  script:
  - isort .

safety:
  stage: Security
  script:
  - safety check

pytest:
  stage: Test
  script:
  - pytest

coverage:
  stage: Test
  allow_failure: true
  script:
  - pytest --cov-report term-missing --cov=bild
